package pwc.taxtech.atms.service;

import java.util.List;

import pwc.taxtech.atms.dpo.UserDto;
import pwc.taxtech.atms.dto.LogOnDto;
import pwc.taxtech.atms.dto.LoginInputDto;
import pwc.taxtech.atms.dto.LoginOutputDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.organization.DimensionRoleDto;
import pwc.taxtech.atms.dto.permission.UserPermissionDto;
import pwc.taxtech.atms.dto.permission.UserPermissionKeyDto;
import pwc.taxtech.atms.dto.user.UserAndUserRoleSaveDto;
import pwc.taxtech.atms.dto.user.UserPasswordDto;
import pwc.taxtech.atms.dto.user.UserRoleDimensionValueDto;
import pwc.taxtech.atms.entity.User;
import pwc.taxtech.atms.entity.UserOrganization;

public interface UserService {
    UserPermissionDto getUserPermission(String userName);

    UserPermissionKeyDto getUserPermissionKey(String userName);

    User getUser(String id);

    OperationResultDto<LoginOutputDto> login(LoginInputDto input);

    OperationResultDto<LogOnDto> changeExternalUserPassword(UserPasswordDto userPasswordDto);

    OperationResultDto<LoginOutputDto> activeCheck(User tempUser);

    OperationResultDto<LoginOutputDto> externalUserLogin(User tempUser, String email, String password);

    UserDto getUserById(String userId);

    List<User> findAllUsers();

    OperationResultDto<User> updateUser(UserAndUserRoleSaveDto userDto);

    OperationResultDto<User> checkEmailExist(String email, String userId);

    OperationResultDto<User> checkUserExist(String userName, String userId);

    void deleteUserDimensionValue(DimensionRoleDto dto, String userId);

    @SuppressWarnings("rawtypes")
    OperationResultDto deleteUserOrg(List<UserRoleDimensionValueDto> userRoleList);
    
    List<UserOrganization> findUserOrganizationByUserIdAndOrganizationId(String userId, String organizationId);

    UserDto getUserByDto(UserDto userParam);
}
