package pwc.taxtech.atms.vat.dao;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.vat.entity.InputVatInvoice;
import pwc.taxtech.atms.vat.entity.InputVatInvoiceExample;

import java.util.List;

@Service
public class InputVatInvoiceDao {
    @Autowired
    InputVatInvoiceMapper inputVATInvoiceMapper;

    public List<InputVatInvoice> getInputVATInvoice(Integer period, Integer invoiceType, String checkPass, String scanPass, String notPass) {
        InputVatInvoiceExample example = new InputVatInvoiceExample();
        InputVatInvoiceExample.Criteria criteria = example.createCriteria();
        InputVatInvoiceExample.Criteria criteria1 = example.createCriteria();

        if (period != null) {

            criteria.andPeriodIdEqualTo(period);
            criteria1.andPeriodIdEqualTo(period);
        }
        if (invoiceType != null) {
            criteria.andInvoiceTypeEqualTo(invoiceType);
            criteria1.andInvoiceTypeEqualTo(invoiceType);
        }

        if (StringUtils.isNotBlank(notPass)) {
            criteria.andCertificationResultEqualTo(notPass);
            criteria1.andCertificationResultEqualTo(notPass);
        } else if (StringUtils.isNotBlank(checkPass) && StringUtils.isNotBlank(scanPass)) {
            criteria.andCertificationResultEqualTo(checkPass);
            criteria.andCertificationResultEqualTo(scanPass);
            example.or(criteria1);
        }

        return inputVATInvoiceMapper.selectByExample(example);
    }
}
