package pwc.taxtech.atms.vat.service.impl;

import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.vat.entity.CellComment;
import pwc.taxtech.atms.vat.entity.CellCommentExample;

import java.util.List;
import java.util.Optional;

@Service
public class CellCommentServiceImpl extends VatAbstractService {
    public OperationResultDto<List<CellComment>> getCellComments(Optional<Long> cellDataId) {
        OperationResultDto resultDto = new OperationResultDto();
        try {
            if (!cellDataId.isPresent() || cellDataId.get() == 0L) {
                resultDto.setResult(false);
                resultDto.setResultMsg("cellDataId is invalid");
                return resultDto;
            }

            CellCommentExample example = new CellCommentExample();
            example.createCriteria().andCellDataIdEqualTo(cellDataId.get());
            List<CellComment> cellComments = cellCommentMapper.selectByExample(example);
            resultDto.setResult(true);
            resultDto.setData(cellComments);
        } catch (Exception ex) {
            logger.error(ex.getMessage(), ex);
            resultDto.setResult(false);
        }
        return resultDto;
    }
}
